/***********************************************************
 * This software is part of the ProM package * http://www.processmining.org/ * *
 * Copyright (c) 2003-2006 TU/e Eindhoven * and is licensed under the * Common
 * Public License, Version 1.0 * by Eindhoven University of Technology *
 * Department of Information Systems * http://is.tm.tue.nl * *
 **********************************************************/

package org.processmining.plugins.declare2ltl;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.Progress;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.declareminer.visualizing.DeclareMap;
import org.processmining.plugins.ltlchecker.model.LTLModel;

@Plugin(name = "Declare to LTL", parameterLabels = { "Declare Model" }, returnLabels = { "LTL Model" }, returnTypes = { LTLModel.class }, userAccessible = true)
public class Declare2ltl {
	Progress prog;

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "F.M. Maggi", email = "F.M.Maggi@tue.nl")
	@PluginVariant(requiredParameterLabels = { 0 }, variantLabel = "Declare to LTL")
	public LTLModel analyse(UIPluginContext context, DeclareMap model) {
		prog = context.getProgress();
		prog.setMinimum(0);
		prog.setMaximum(112);
		prog.setIndeterminate(false);
		prog.setValue(50);
		LTLModel res = LTLGenerator.generate(model.getModel());
		prog.setValue(100);
		return res;
	}

}
