package org.processmining.plugins.declareminer;

import java.io.File;

import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.in.XMxmlGZIPParser;
import org.deckfour.xes.in.XMxmlParser;
import org.deckfour.xes.in.XesXmlGZIPParser;
import org.deckfour.xes.in.XesXmlParser;
import org.deckfour.xes.model.XLog;
import org.processmining.plugins.declareminer.visualizing.AssignmentModel;
import org.processmining.plugins.declareminer.visualizing.AssignmentModelView;
import org.processmining.plugins.declareminer.visualizing.AssignmentViewBroker;
import org.processmining.plugins.declareminer.visualizing.DeclareMap;
import org.processmining.plugins.declareminer.visualizing.XMLBrokerFactory;

public class ExistTest {

	public static void main(String[] args) {
		// TODO Auto-generated method stub

		String filepath = "C:\\Users\\Fabrizio\\Desktop\\inputModel.xml";
		String outputPath = "C:\\Users\\Fabrizio\\Desktop\\outputModel.xml";
		String inputLogFileName = "SelectedLog.xes";
		
		AssignmentViewBroker broker = XMLBrokerFactory.newAssignmentBroker(filepath);
		AssignmentModel model = broker.readAssignment();
		AssignmentModelView view = new AssignmentModelView(model);
		broker.readAssignmentGraphical(model, view);
		
		DeclareMap outputMap = new DeclareMap(model, null, view, null, null, null);
		
		XLog log = null;

		if(inputLogFileName .toLowerCase().contains("mxml.gz")){
			XMxmlGZIPParser parser = new XMxmlGZIPParser();
			if(parser.canParse(new File(inputLogFileName))){
				try {
					log = parser.parse(new File(inputLogFileName)).get(0);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}else if(inputLogFileName.toLowerCase().contains("mxml")){
			XMxmlParser parser = new XMxmlParser();
			if(parser.canParse(new File(inputLogFileName))){
				try {
					log = parser.parse(new File(inputLogFileName)).get(0);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		if(inputLogFileName.toLowerCase().contains("xes.gz")){
			XesXmlGZIPParser parser = new XesXmlGZIPParser();
			if(parser.canParse(new File(inputLogFileName))){
				try {
					log = parser.parse(new File(inputLogFileName)).get(0);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}else if(inputLogFileName.toLowerCase().contains("xes")){
			XesXmlParser parser = new XesXmlParser();
			if(parser.canParse(new File(inputLogFileName))){
				try {
					log = parser.parse(new File(inputLogFileName)).get(0);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		XFactory fact = XFactoryRegistry.instance().currentDefault();
		log.add(fact.createTrace());
		
		DeclareMap newModel = DeclareMiner.discoverExistentials(log, false, outputMap);
		
		broker = XMLBrokerFactory.newAssignmentBroker(outputPath);
		broker.addAssignmentAndView(newModel.getModel(),newModel.getView());

	}	
}
