package org.processmining.plugins.declareminer;

public class ExistentialConstraintsUtility {

	public static String getLTLExistenceFormula(int atLeast){

		String output = "<>(\"A\")";

		for(int i=1; i< atLeast; i++){
			output = "<>( \"A\" /\\ "+"X("+output+") )";
		}

		return output;
	}

	public static String getLTLAbsenceFormula(int atMost){
		String output = "<>(\"A\")";

		for(int i=1; i<= atMost; i++){
			output = "<>( \"A\" /\\ "+"X("+output+") )";
		}

		return "!("+output+")";
	}

	public static String getExistenceTemplate(int atLeast){

		String output = "existence";

		if(atLeast>1){
			output = output+atLeast;
		}

		return output;
	}

	public static String getAbsenceTemplate(int atMost){
		String output = "absence";

		int index = atMost+1;
		if(index>1){
			output = output+index;
		}

		return output;	
	}
	
	public static String getExistenceDisplay(int atLeast){
		return atLeast+"..*";
	}

	public static String getAbsenceDisplay(int atMost){
		String output = "0";
		if(atMost>0){
			output = output+".."+atMost;
		}
		return output;	
	}
}
