package org.processmining.plugins.declareminer.templates;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.extension.std.XLifecycleExtension;
import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.plugins.declareminer.DeclareMinerInput;
import org.processmining.plugins.declareminer.MetricsValues;
import org.processmining.plugins.declareminer.apriori.FindItemSets;
import org.processmining.plugins.declareminer.enumtypes.AprioriKnowledgeBasedCriteria;
import org.processmining.plugins.declareminer.enumtypes.DeclareTemplate;
import org.processmining.plugins.declareminer.enumtypes.FrequentItemSetType;
import org.processmining.plugins.declareminer.visualizing.ActivityDefinition;
import org.processmining.plugins.declareminer.visualizing.ConstraintDefinition;

public class PrecedenceInfo extends TemplateInfo {



	public Vector<MetricsValues> getMetrics(DeclareMinerInput input, Map<FrequentItemSetType, Map<Set<String>, Float>> frequentItemSetTypeFrequentItemSetSupportMap, Map<DeclareTemplate, List<List<String>>> declareTemplateCandidateDispositionsMap, float alpha, float support,
			XLog log, PrintWriter pw, DeclareTemplate currentTemplate,
			UIPluginContext context, boolean verbose, FindItemSets f){
		numberOfDiscoveredConstraints = 0;
		if(metricsValues4precedence==null){
			metricsValues4precedence = new HashMap<String, MetricsValues>();
		}
		Vector<MetricsValues> metricsValues = new Vector<MetricsValues>();
		List<List<String>> declareTemplateCandidateDispositionsList = declareTemplateCandidateDispositionsMap.get(currentTemplate);
		if(declareTemplateCandidateDispositionsList==null){
			declareTemplateCandidateDispositionsList = new ArrayList<List<String>>();
		}
		List<List<String>> actualParametersList = new ArrayList<List<String>>();
		for(int k=0; k< declareTemplateCandidateDispositionsList.size(); k++){
			List<String> actualParameters = new ArrayList<String>();
			actualParameters.add(declareTemplateCandidateDispositionsList.get(k).get(1));
			actualParameters.add(declareTemplateCandidateDispositionsList.get(k).get(0));
			actualParametersList.add(actualParameters);
		}
		for(int k=0; k< actualParametersList.size(); k++){
			if(context!=null){context.getProgress().inc();}
			MetricsValues values = null;
			String formula = LTLFormula.getFormulaByTemplate(currentTemplate);
			formula = formula.replace( "\""+"A"+"\"" , "\""+actualParametersList.get(k).get(0)+"\"");
			formula = formula.replace( "\""+"B"+"\"" , "\""+actualParametersList.get(k).get(1)+"\"");

			if((metricsValues4precedence.containsKey(currentTemplate+";"+actualParametersList.get(k).get(0)+";"+actualParametersList.get(k).get(1)))){
				values = metricsValues4precedence.get(currentTemplate+";"+actualParametersList.get(k).get(0)+";"+actualParametersList.get(k).get(1));
				printMetrics(pw, formula, values.getSupportRule(), values.getConfidence(), values.getSuppAntec(), +values.getSupportConseq(), values.getSuppAntecSat(), values.getSupportConseqSat(), values.getI(), values.getCPIR());
			}else{
				if(verbose){
					values = computeMetrics(input, currentTemplate, actualParametersList.get(k), log, pw, alpha,f);
				}else{
					values = computeMetrics(input, currentTemplate, actualParametersList.get(k), log, null, alpha,f);
				}
				metricsValues4precedence.put(currentTemplate+";"+actualParametersList.get(k).get(0)+";"+actualParametersList.get(k).get(1), values);
			}
			if(values.getSupportRule()>=support){
				numberOfDiscoveredConstraints ++;
			}
			metricsValues.add(values);
		}
		return metricsValues;
	}




	public Vector<Long> getTimeDistances(DeclareMinerInput input, XTrace trace, ConstraintDefinition constraintDefinition, Set<Integer> fulfillments) {
		Vector<Long> timeDists = new Vector<Long>();
		for(Integer pos : fulfillments){
			boolean found = false;
			XEvent act = trace.get(pos);
			for(int c=pos; c>=0; c--){
				XEvent event = trace.get(c);
				ActivityDefinition target = constraintDefinition.getBranches(constraintDefinition.getParameters().iterator().next()).iterator().next();
				String activityName = target.getName();
				String eventName = (XConceptExtension.instance().extractName(event));
				//}
				if(input.getAprioriKnowledgeBasedCriteriaSet().contains(AprioriKnowledgeBasedCriteria.AllActivitiesWithEventTypes)){
					if(!containsEventType(target.getName())){
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							activityName = target.getName()+"-"+input.getReferenceEventType();
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}
					}else{
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}else{
							eventName = (XConceptExtension.instance().extractName(event))+"-"+input.getReferenceEventType();
						}
					}
				}
				if(eventName.equals(activityName)){
					found = true;
					long timeDistance1 = XTimeExtension.instance().extractTimestamp(act).getTime();
					long timeDistance2 = XTimeExtension.instance().extractTimestamp(event).getTime();
					long timeDiff = timeDistance1 - timeDistance2;
					timeDists.add(timeDiff);

				}
				if(found){
					break;
				}
			}
		}
		return timeDists;
	}




}
