package org.processmining.plugins.declareminer.templates;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.extension.std.XLifecycleExtension;
import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.plugins.declareminer.DeclareMinerInput;
import org.processmining.plugins.declareminer.MetricsValues;
import org.processmining.plugins.declareminer.apriori.FindItemSets;
import org.processmining.plugins.declareminer.enumtypes.AprioriKnowledgeBasedCriteria;
import org.processmining.plugins.declareminer.enumtypes.DeclareTemplate;
import org.processmining.plugins.declareminer.enumtypes.FrequentItemSetType;
import org.processmining.plugins.declareminer.visualizing.ActivityDefinition;
import org.processmining.plugins.declareminer.visualizing.ConstraintDefinition;
import org.processmining.plugins.declareminer.visualizing.Parameter;

public class RespondedExistenceInfo extends TemplateInfo{

	


	public Vector<MetricsValues> getMetrics(DeclareMinerInput input, Map<FrequentItemSetType, Map<Set<String>, Float>> frequentItemSetTypeFrequentItemSetSupportMap, Map<DeclareTemplate, List<List<String>>> declareTemplateCandidateDispositionsMap, float alpha, float support,
			XLog log, PrintWriter pw, DeclareTemplate currentTemplate,
			UIPluginContext context, boolean verbose, FindItemSets f){
		numberOfDiscoveredConstraints = 0;
		Vector<MetricsValues> metricsValues = new Vector<MetricsValues>();
		List<List<String>> declareTemplateCandidateDispositionsList = declareTemplateCandidateDispositionsMap.get(currentTemplate);
		if(declareTemplateCandidateDispositionsList==null){
			declareTemplateCandidateDispositionsList = new ArrayList<List<String>>();
		}
		for(int k=0; k< declareTemplateCandidateDispositionsList.size(); k++){
			if(context!=null){context.getProgress().inc();}
			MetricsValues values = null;
			if(verbose){
				values = computeMetrics(input,currentTemplate, declareTemplateCandidateDispositionsList.get(k), log, pw, alpha,f);
			}else{
				values = computeMetrics(input,currentTemplate, declareTemplateCandidateDispositionsList.get(k), log, null, alpha,f);
			}
			if(values.getSupportRule()>=support){
				numberOfDiscoveredConstraints ++;
			}
			metricsValues.add(values);
		}
		return metricsValues;
	}

	public Vector<Long> getTimeDistances(DeclareMinerInput input, XTrace trace, ConstraintDefinition constraintDefinition, Set<Integer> fulfillments) {
		long timeDiff1 = -1;
		long timeDiff2 = -1;
		Vector<Long> timeDists = new Vector<Long>(); 
		for(Integer pos : fulfillments){
			boolean found = false;
			XEvent act = trace.get(pos);
			for(int c=pos; c<trace.size(); c++){
				XEvent event = trace.get(c);
				Iterator<Parameter> iter = constraintDefinition.getParameters().iterator();
				iter.next();
				Parameter p2 = iter.next();
				ActivityDefinition target = constraintDefinition.getBranches(p2).iterator().next();

				String activityName = target.getName();
				String eventName = (XConceptExtension.instance().extractName(event));
				//}
				if(input.getAprioriKnowledgeBasedCriteriaSet().contains(AprioriKnowledgeBasedCriteria.AllActivitiesWithEventTypes)){
					if(!containsEventType(target.getName())){
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							activityName = target.getName()+"-"+input.getReferenceEventType();
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}
					}else{
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}else{
							eventName = (XConceptExtension.instance().extractName(event))+"-"+input.getReferenceEventType();
						}
					}
				}
				if(eventName.equals(activityName)){
					found = true;
					long timeDistance1 = XTimeExtension.instance().extractTimestamp(event).getTime();
					long timeDistance2 = XTimeExtension.instance().extractTimestamp(act).getTime();
					timeDiff1 = timeDistance1 - timeDistance2;
				}
				if(found){
					break;
				}
			}

			found = false;

			for(int c=pos; c>=0; c--){
				XEvent event = trace.get(c);
				Iterator<Parameter> iter = constraintDefinition.getParameters().iterator();
				iter.next();
				Parameter p2 = iter.next();
				ActivityDefinition target = constraintDefinition.getBranches(p2).iterator().next();

				String activityName = target.getName();
				String eventName = (XConceptExtension.instance().extractName(event));
				//}
				if(input.getAprioriKnowledgeBasedCriteriaSet().contains(AprioriKnowledgeBasedCriteria.AllActivitiesWithEventTypes)){
					if(!containsEventType(target.getName())){
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							activityName = target.getName()+"-"+input.getReferenceEventType();
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}
					}else{
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}else{
							eventName = (XConceptExtension.instance().extractName(event))+"-"+input.getReferenceEventType();
						}
					}
				}
				if(eventName.equals(activityName)){
					found = true;
					long timeDistance1 = XTimeExtension.instance().extractTimestamp(act).getTime();
					long timeDistance2 = XTimeExtension.instance().extractTimestamp(event).getTime();
					timeDiff2 = timeDistance1 - timeDistance2;
				}
				if(found){
					break;
				}
			}

			long timeDiff =0;
			if((timeDiff1!=-1)&&(timeDiff2!=-1)&&(timeDiff2<=timeDiff1)){
				timeDiff = timeDiff2;
			}
			if((timeDiff2!=-1)&&(timeDiff1!=-1)&&(timeDiff1<=timeDiff2)){
				timeDiff = timeDiff1;
			}
			if((timeDiff1!=-1)&&(timeDiff2==-1)){
				timeDiff = timeDiff1;
			}
			if((timeDiff2!=-1)&&(timeDiff1==-1)){
				timeDiff = timeDiff2;
			}
		//	if(timeDiff!=0){
				timeDists.add(timeDiff);
		//	}
		}
		return timeDists;
	}


	
}
