package org.processmining.plugins.declareminer.templates;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.extension.std.XLifecycleExtension;
import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.plugins.declareminer.DeclareMinerInput;
import org.processmining.plugins.declareminer.MetricsValues;
import org.processmining.plugins.declareminer.apriori.FindItemSets;
import org.processmining.plugins.declareminer.enumtypes.AprioriKnowledgeBasedCriteria;
import org.processmining.plugins.declareminer.enumtypes.DeclareTemplate;
import org.processmining.plugins.declareminer.enumtypes.FrequentItemSetType;
import org.processmining.plugins.declareminer.visualizing.ActivityDefinition;
import org.processmining.plugins.declareminer.visualizing.ConstraintDefinition;
import org.processmining.plugins.declareminer.visualizing.Parameter;

public class ResponseInfo extends TemplateInfo {

	

	public Vector<MetricsValues> getMetrics(DeclareMinerInput input, Map<FrequentItemSetType, Map<Set<String>, Float>> frequentItemSetTypeFrequentItemSetSupportMap, Map<DeclareTemplate, List<List<String>>> declareTemplateCandidateDispositionsMap, float alpha, float support,
			XLog log, PrintWriter pw, DeclareTemplate currentTemplate,
			UIPluginContext context, boolean verbose, FindItemSets f){
		numberOfDiscoveredConstraints = 0;
		Vector<MetricsValues> metricsValues = new Vector<MetricsValues>();
		if(metricsValues4response==null){
			metricsValues4response = new HashMap<String, MetricsValues>();
		}
		List<List<String>> declareTemplateCandidateDispositionsList = declareTemplateCandidateDispositionsMap.get(currentTemplate);
		if(declareTemplateCandidateDispositionsList==null){
			declareTemplateCandidateDispositionsList = new ArrayList<List<String>>();
		}
		for(int k=0; k< declareTemplateCandidateDispositionsList.size(); k++){
			if(context!=null){context.getProgress().inc();}
			MetricsValues values = null;
			String formula = LTLFormula.getFormulaByTemplate(currentTemplate);
			formula = formula.replace( "\""+"A"+"\"" , "\""+declareTemplateCandidateDispositionsList.get(k).get(0)+"\"");
			formula = formula.replace( "\""+"B"+"\"" , "\""+declareTemplateCandidateDispositionsList.get(k).get(1)+"\"");
			if(metricsValues4response.containsKey(currentTemplate+";"+declareTemplateCandidateDispositionsList.get(k).get(0)+";"+declareTemplateCandidateDispositionsList.get(k).get(1))){
				values = metricsValues4response.get(currentTemplate+";"+declareTemplateCandidateDispositionsList.get(k).get(0)+";"+declareTemplateCandidateDispositionsList.get(k).get(1));
				printMetrics(pw, formula, values.getSupportRule(), values.getConfidence(), values.getSuppAntec(), +values.getSupportConseq(), values.getSuppAntecSat(), values.getSupportConseqSat(), values.getI(), values.getCPIR());
			}else{
				if(verbose){
					values = computeMetrics(input,currentTemplate, declareTemplateCandidateDispositionsList.get(k), log, pw, alpha,f);
				}else{
					values = computeMetrics(input,currentTemplate, declareTemplateCandidateDispositionsList.get(k), log, null, alpha,f);
				}
				metricsValues4response.put(currentTemplate+";"+declareTemplateCandidateDispositionsList.get(k).get(0)+";"+declareTemplateCandidateDispositionsList.get(k).get(1), values);
			}
			if(values.getSupportRule()>=support){
				numberOfDiscoveredConstraints ++;
			}
			System.out.println("I am in ResponseInfo");
			System.out.println("interest factor"+  declareTemplateCandidateDispositionsList.get(k)+": "+values.getI());
			metricsValues.add(values);
		}
		return metricsValues;
	}


	public Vector<Long> getTimeDistances(DeclareMinerInput input, XTrace trace, ConstraintDefinition constraintDefinition, Set<Integer> fulfillments) {
		Vector<Long> timeDists = new Vector<Long>();
		System.out.println("sono dentro, valutazione constraint numero fulfill "+ fulfillments.size());
		for(Integer pos : fulfillments){
			System.out.println("sono dentro pos");
			boolean found = false;
			XEvent act = trace.get(pos);
			for(int c=pos; c<trace.size(); c++){
				System.out.println("sono dentro c");
				XEvent event = trace.get(c);
				Iterator<Parameter> iter = constraintDefinition.getParameters().iterator();
				iter.next();
				Parameter p2 = iter.next();
				ActivityDefinition target = constraintDefinition.getBranches(p2).iterator().next();
				if(target.getName().equals((XConceptExtension.instance().extractName(act)))){
					target = constraintDefinition.getBranches(constraintDefinition.getParameterWithId(1)).iterator().next();
				}

				//	target = constraintDefinition.getBranches(constraintDefinition.getParameters().iterator().next()).iterator().next();
				String activityName = target.getName();
				String eventName = (XConceptExtension.instance().extractName(event));
				//}
				if(input.getAprioriKnowledgeBasedCriteriaSet().contains(AprioriKnowledgeBasedCriteria.AllActivitiesWithEventTypes)){
					if(!containsEventType(target.getName())){
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							activityName = target.getName()+"-"+input.getReferenceEventType();
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}
					}else{
						if(event.getAttributes().get(XLifecycleExtension.KEY_TRANSITION)!=null){
							eventName = (XConceptExtension.instance().extractName(event))+"-"+XLifecycleExtension.instance().extractTransition(event);
						}else{
							eventName = (XConceptExtension.instance().extractName(event))+"-"+input.getReferenceEventType();
						}
					}
				}
				if(eventName.equals(activityName)){
					found = true;
					long timeDistance1 = XTimeExtension.instance().extractTimestamp(event).getTime();
					long timeDistance2 = XTimeExtension.instance().extractTimestamp(act).getTime();
					long timeDiff = timeDistance1 - timeDistance2;
					timeDists.add(timeDiff);
					//					if(constraintDefinition.getName().equals("chain response")){
					//						System.out.println("quiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii: "+XConceptExtension.instance().extractName(act)+"       "+target.getName()+timeDiff);
					//					}
				}
				if(found){
					break;
				}
			}
		}
		System.out.println("sono fuori responseInfo");
		return timeDists;
	}

	
}
